VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSubTree"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

Implements ISubClass

Public Event SelectionChange()

Private WithEvents m_TreeView As TreeView
Attribute m_TreeView.VB_VarHelpID = -1
Private m_CurrentItem As TVINSERTSTRUCT
Private m_SysImgList As Long


' ***************************************************************************************
' Initialization, finalization
' ***************************************************************************************
Public Sub ConstructObject(ByVal tvw As TreeView)
    Set m_TreeView = tvw
    Call SubClass.Recipients.Add(Me)
    Call AssignSysImageList
End Sub
Private Sub AssignSysImageList()
    m_SysImgList = VB6Core.GFileUtil.GetSystemImageList
    If m_SysImgList <> 0 Then
        Call SendMessage(m_TreeView.hWnd, TVM_SETIMAGELIST, TVSIL.Normal, m_SysImgList)
    End If
End Sub


' ***************************************************************************************
' Properties
' ***************************************************************************************
Public Property Get Folder() As String
On Error GoTo hell
    Dim so As ShellObject
    Set so = Me.ShellObject
    If (so Is Nothing) = False Then
            Folder = so.Path
    End If
    Exit Property
hell:
End Property
Public Property Let Folder(ByVal sFolder As String)
On Error GoTo hell
    ' check
    If sFolder = "" Then GoTo hell
    Dim fx As New CFileExecution
    If fx.CheckPath(sFolder, fxsFolder) = False Then GoTo hell
    ' find shell object
    Dim so As ShellObject: Set so = New ShellObject
    Call so.BindToPath(sFolder)
    Dim col As Collection: Set col = New Collection
    Do Until so.Parent Is Nothing
        If col.Count = 0 Then
                    col.Add so
            Else:   col.Add so, , 1
        End If
        Set so = so.Parent
    Loop
    ' refresh tree
    Call RefreshTree
    ' walk through collection && compare child nodes
    Dim i As Long, nde As Node
    Set nde = m_TreeView.Nodes(1)
    For i = 1 To col.Count
        Set so = col.item(i)
        nde.Expanded = True
        Set nde = nde.child
        Do Until nde Is Nothing
            If StrComp(nde.Tag.DisplayName, so.DisplayName, vbBinaryCompare) = 0 Then
                Exit Do
            End If
            Set nde = nde.Next
        Loop
        ' failed?
        If nde Is Nothing Then Exit For
    Next i
    ' set selection
    Set m_TreeView.SelectedItem = nde
    RaiseEvent SelectionChange
    Exit Property
hell:
End Property
Public Property Get ShellObject() As ShellObject
On Error GoTo hell
    Dim nde As Node
    Set nde = m_TreeView.SelectedItem
    If (nde Is Nothing) = False Then
        Dim so As ShellObject
        Set ShellObject = nde.Tag
    End If
    Exit Property
hell:
End Property


' ***************************************************************************************
' Methods
' ***************************************************************************************
Public Sub RefreshTree()
On Error GoTo hell
    Call ClearTree
    Call AddRoot
    RaiseEvent SelectionChange
    Exit Sub
hell:
End Sub
Public Sub ClearTree()
On Error GoTo hell
    m_TreeView.Nodes.Clear
    Exit Sub
hell:
End Sub
Private Sub AddRoot()
On Error GoTo hell
    Dim so As ShellObject
    Set so = New ShellObject
    so.BindToDesktop
    Call AddNode(0, so)
    Exit Sub
hell:
End Sub
Private Sub AddNode(ByVal hParent As Long, ByVal so As ShellObject)
On Error GoTo hell
    ' fill item from so
    Dim item As TVITEM
    item.pszText = StrPtr(String$(MAX_PATH, 0))
    Call lstrcpyA(ByVal item.pszText, ByVal so.DisplayName)
    item.cchTextMax = MAX_PATH
    item.iImage = so.IconIndex(0, 0)
    item.iSelectedImage = so.IconIndex(1, 0)
    item.lParam = ObjPtr(so)
    If m_TreeView.Nodes.Count = 0 Then
                item.cChildren = 1
        Else:   item.cChildren = Abs(so.HasSubFolders)
    End If
    item.mask = TVIF.Text Or TVIF.Image Or TVIF.SelectedImage Or TVIF.Param Or TVIF.Children
    ' insertstruct
    m_CurrentItem.item = item
    m_CurrentItem.hParent = hParent
    ' call (we'll intercept the msg)
    Dim nde As Node
    Set nde = m_TreeView.Nodes.Add
    Set nde.Tag = so
    Exit Sub
hell:
End Sub
Friend Sub AddChildren(ByVal hParent As Long, ByVal so As ShellObject)
On Error GoTo hell
    Dim i As Long
    so.SubMode = 1
    so.RefreshSubItems
    For i = 1 To so.SubItemCount
        Call AddNode(hParent, so.SubItems(i))
    Next i
    Exit Sub
hell:
End Sub
Friend Sub RemoveChildren(ByVal nde As Node)
On Error GoTo hell
    Dim child As Node, index As Long
    Set child = nde.child
    Do Until child Is Nothing
        index = child.index
        Set child = child.Next
        m_TreeView.Nodes.Remove index
    Loop
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Handlers
' ***************************************************************************************
Private Sub m_TreeView_NodeClick(ByVal Node As MSComctlLib.Node)
On Error GoTo hell
    RaiseEvent SelectionChange
    Exit Sub
hell:
End Sub
Private Sub m_TreeView_Collapse(ByVal Node As MSComctlLib.Node)
On Error GoTo hell
    RaiseEvent SelectionChange
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Subclassing
' ***************************************************************************************
Private Property Get ISubClass_Handle() As Long
On Error GoTo hell
    ISubClass_Handle = m_TreeView.hWnd
    Exit Property
hell:
End Property
Private Sub ISubClass_WndProc(ByVal message As SubClass.CMessage)
On Error GoTo hell
    Select Case message.wMsg
        Case TVM_SETIMAGELIST
            ' use sys il only
            If message.lParam <> m_SysImgList Then
                message.Handled = True
            End If
        Case TVM_INSERTITEM
            ' trick treeview
            Call CopyMemory(ByVal message.lParam, m_CurrentItem, Len(m_CurrentItem))
    End Select
    Exit Sub
hell:
End Sub




